//lRegen_FileHeading
//lRegen_FileHeading

     /********************************************************************
      *
      *   Source File:  idoiface.c
      *   Author:
      *   Module:       Source for idoiface application
      *   Program Desc:
      *   Date:         Wed Apr 03 07:33:30 1996
      *   Language:     ANSI C
      *
      ********************************************************************/

#include ".\idoiface.h"

#include "ctl3d.h"
//lRegen_Variables

#include <memory.h>
#include <pvido.h>

HMENU hIDO, hEntity, hLine;

extern BOOL bMsg;

void SetItemFont(LOGFONT *);

//lRegen_Variables

HMENU    hMainMenu;
#define  IDM_FIRSTCHILD 3
HINSTANCE   hInstance;
char        szAppName[30];
HMENU       hMenuInit;
HWND        hWndClient, hWndFrame;
#define     MAIN_POS  5
HMENU       hMenu_MAIN_Pos;

BOOL bOFRetCode;
char szOFFilePath[80];
char szOFFileTitle[40];
OPENFILENAME ofOF;
static char szOFFilter[] = {
   "Diagram File\0"
   "*.IDO\0"
   "\0"
};
BOOL bSFRetCode;
char szSFFilePath[80];
char szSFFileTitle[40];
OPENFILENAME ofSF;
static char szSFFilter[] = {
   "Diagram File\0"
   "*.IDO\0"
   "\0"
};
BOOL bPALETTERetCode;
char szPALETTEFilePath[80];
char szPALETTEFileTitle[40];
OPENFILENAME ofPALETTE;
static char szPALETTEFilter[] = {
   "Palette File\0"
   "*.PLT\0"
   "\0"
};
BOOL bPLT2RetCode;
char szPLT2FilePath[80];
char szPLT2FileTitle[40];
OPENFILENAME ofPLT2;
static char szPLT2Filter[] = {
   "Palette File\0"
   "*.PLT\0"
   "\0"
};
BOOL       bCFRetCode;
CHOOSEFONT cfCF;
LOGFONT    lfCF;
LRESULT CALLBACK EXPORT MainWndProc(HWND, UINT, WPARAM, LPARAM);
HACCEL   hAccel;

int PASCAL WinMain(HINSTANCE hInst,          // Application Instance Handle
                   HINSTANCE hPrevInstance,  // Previous Instance Handle
                   LPSTR  lpszCmdLine,       // Pointer to Command Line
                   int    nCmdShow)          // Show Window Option
{
   //lRegen_BeginFunction
   //lRegen_BeginFunction

   MSG      msg;
   HWND     hWndMain;

   HMODULE hWinControl;

   WNDCLASS wndclass;
   hInstance = hInst;

   lstrcpy(szAppName, "idoiface");
   #ifdef WIN32
      #define WINCTL_LIB  "winctl32.dll"
   #else
      #define WINCTL_LIB  "winctl.dll"
   #endif

   hWinControl = LoadLibrary(WINCTL_LIB);
   if((UINT)hWinControl <= 32)
      MessageBox(NULL, "Unable to load WinControl Library", "System Error", MB_OK | MB_ICONHAND);
   hAccel = LoadAccelerators(hInstance, "idoiface");

   if(!hPrevInstance)
   {
      wndclass.style           = CS_HREDRAW | CS_VREDRAW;
      wndclass.lpfnWndProc     = MainWndProc;
      wndclass.cbClsExtra      = 0;
      wndclass.cbWndExtra      = 0;
      wndclass.hInstance       = hInstance;
      wndclass.hCursor         = LoadCursor(NULL, IDC_ARROW);
      wndclass.hIcon           = LoadIcon(hInstance, "idoiface");
      wndclass.hbrBackground   = (HBRUSH)COLOR_APPWORKSPACE;
      wndclass.lpszMenuName    = "idoiface";
      wndclass.lpszClassName   = szAppName;

      if(!RegisterClass(&wndclass))
         return FALSE;
   }

   Ctl3dRegister(hInstance);
   Ctl3dAutoSubclass(hInstance);
   //lRegen_InitView

   /*
    *   set global data to 0
    */
   memset(&gData, 0, sizeof(gData));

   /*
    *   save application instance handle
    */
   gData.hApp = hInst;

   /*
    *   attempt to load pvIDO dll.  If it fails, display a error message box.
    */
   gData.hIDOdll = IDO_LoadDLL();
   if(!gData.hIDOdll)
      MessageBox(NULL, "Error loadind pvIDO dll.", "System Error", MB_OK | MB_ICONSTOP);


   //lRegen_InitView

   if(NULL == (hWndMain = CreateWindow(szAppName,
                       "ProtoView InterAct",
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, 0,
                       CW_USEDEFAULT, 0,
                       NULL, (HMENU)NULL, hInstance, NULL)))
        return FALSE;

   hMenuInit = GetMenu(hWndMain);
   hMenu_MAIN_Pos = GetSubMenu(GetMenu(hWndMain), MAIN_POS);


   hWndClient = GetWindow (hWndMain, GW_CHILD);
   hWndFrame  = hWndMain;
   //lRegen_MainWnd
   //lRegen_MainWnd
   vwSetViewToolBar(hWndMain, MAKEINTRESOURCE(TopToolbar), fnTopToolbarWndProc, PV_TOP);
   vwSetViewToolBar(hWndMain, MAKEINTRESOURCE(StatusLine), fnStatusLineWndProc, PV_BOTTOM);
   vwSetStatusLineId(hWndMain, IDC_STATUS1);

   ShowWindow(hWndMain, nCmdShow);
   UpdateWindow(hWndMain);

   while(GetMessage(&msg, NULL, 0, 0))
       if (!TranslateMDISysAccel (hWndClient, &msg))
         if(!TranslateAccelerator(hWndMain, hAccel, &msg))
          {
             TranslateMessage(&msg);
             DispatchMessage(&msg);
          }

   if((UINT)hWinControl > 32)
      FreeLibrary(hWinControl);

   //Regen_AppTerm

   /*
    *   Free pvIDO dll
    */
   if(gData.hIDOdll)
      IDO_FreeDLL(gData.hIDOdll);

   //Regen_AppTerm
   return msg.wParam;
}

LRESULT CALLBACK EXPORT MainWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
HWND               hWndChild;
CLIENTCREATESTRUCT clientcreate;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   //lRegen_WindowProcVariables
   ENTITY entity;
   //lRegen_WindowProcVariables

   switch(uMessage)
   {
       //lRegen_WndProc

       case WM_USER + 23 :

          SENDCOMMAND(hWnd, CM_FILENEW, 0, 0L);

          break;

       //lRegen_WndProc

      case WM_CREATE :
         //Regen_WM_CREATE

         fnBanner(hWnd, 0, 0L);

         hIDO = CreatePopupMenu();
         AppendMenu(hIDO, MF_ENABLED | MF_STRING, POP_IDM_USERSTART, "My IDO Menu");

         hEntity = CreatePopupMenu();
         AppendMenu(hEntity, MF_ENABLED | MF_STRING, POP_IDM_USERSTART +1, "My Entity Menu");

         hLine = CreatePopupMenu();
         AppendMenu(hLine, MF_ENABLED | MF_STRING, POP_IDM_USERSTART +2, "My Line Menu");

         PostMessage(hWnd, WM_USER + 23, 0, 0L);

         //Regen_WM_CREATE
         // Create the client window

         clientcreate.hWindowMenu  = hMainMenu;
         clientcreate.idFirstChild = IDM_FIRSTCHILD;

         hWndClient = CreateWindow("MDICLIENT", NULL,
                         WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
                         0, 0, 0, 0, hWnd, (HMENU)1, hInstance,
                         (LPSTR) &clientcreate);
         return 0;

      case WM_DESTROY :
         //Regen_WM_DESTROY
         //Regen_WM_DESTROY
         break;

      case WM_INITMENUPOPUP :
         //Regen_WM_INITMENUPOPUP

         if(bMsg)
            CheckMenuItem(GetMenu(hWnd), IDM_DISPLAYMESSAGES, MF_BYCOMMAND | MF_CHECKED);
         else
            CheckMenuItem(GetMenu(hWnd), IDM_DISPLAYMESSAGES, MF_BYCOMMAND | MF_UNCHECKED);

         if(GetAlignPaletteWnd())
            CheckMenuItem(GetMenu(hWnd), IDM_ALIGNMENTPALETTE, MF_BYCOMMAND | MF_CHECKED);
         else
            CheckMenuItem(GetMenu(hWnd), IDM_ALIGNMENTPALETTE, MF_BYCOMMAND | MF_UNCHECKED);

         if(GetColorPaletteWnd())
            CheckMenuItem(GetMenu(hWnd), IDM_COLORPALETTE, MF_BYCOMMAND | MF_CHECKED);
         else
            CheckMenuItem(GetMenu(hWnd), IDM_COLORPALETTE, MF_BYCOMMAND | MF_UNCHECKED);


         if(GetActiveIDO())
         {
            if(idoGetPopupMenu(GetActiveIDO(), IDOMENU_IDO))
               CheckMenuItem(GetMenu(hWnd), IDM_USEIDOMENUS, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_USEIDOMENUS, MF_BYCOMMAND | MF_UNCHECKED);

            if(idoGetEditMode(GetActiveIDO()))
               CheckMenuItem(GetMenu(hWnd), IDM_EDITMODE, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_EDITMODE, MF_BYCOMMAND | MF_UNCHECKED);

            if(idoGetToolsPalette(GetActiveIDO()))
               CheckMenuItem(GetMenu(hWnd), IDM_TOOLPALETTE, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_TOOLPALETTE, MF_BYCOMMAND | MF_UNCHECKED);

            if(idoGetSnapToGrid(GetActiveIDO()))
               CheckMenuItem(GetMenu(hWnd), IDM_SNAPTOGRID, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_SNAPTOGRID, MF_BYCOMMAND | MF_UNCHECKED);

            if(idoGetGridLines(GetActiveIDO()))
               CheckMenuItem(GetMenu(hWnd), IDM_GRIDLINES, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_GRIDLINES, MF_BYCOMMAND | MF_UNCHECKED);

            if(idoGetRulesEnforced(GetActiveIDO()))
               CheckMenuItem(GetMenu(hWnd), IDM_ENFORCERULES, MF_BYCOMMAND | MF_CHECKED);
            else
               CheckMenuItem(GetMenu(hWnd), IDM_ENFORCERULES, MF_BYCOMMAND | MF_UNCHECKED);


            if(idoGetCurrentEntity(GetActiveIDO(), &entity))
               EnableMenuItem(GetMenu(hWnd), IDM_SETCURRENTENTITYTEXT, MF_BYCOMMAND | MF_ENABLED);
            else
               EnableMenuItem(GetMenu(hWnd), IDM_SETCURRENTENTITYTEXT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);


            EnableMenuItem(GetMenu(hWnd), IDM_CUT, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_COPY, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_PASTE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), CM_FILESAVE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_SAVEAS, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_CLOSE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_RESET, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), CM_FILEPRINT, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMIN, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMOUT, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMTOFITWINDOW, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_SNAPTOGRID, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_TOOLPALETTE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_USEIDOMENUS, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_EDITMODE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ENFORCERULES, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_GRIDLINES, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ADDE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_DELETEE, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_ADDREL, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_DELETERELATION, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETUSERMENUS, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_RESETMENUS, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETETEXT, MF_BYCOMMAND | MF_ENABLED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETCURRENTENTITY, MF_BYCOMMAND | MF_ENABLED);
         }
         else
         {
            EnableMenuItem(GetMenu(hWnd), IDM_SETCURRENTENTITYTEXT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_CUT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_COPY, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_PASTE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), CM_FILESAVE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_SAVEAS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_CLOSE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_RESET, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), CM_FILEPRINT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMIN, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMOUT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_ZOOMTOFITWINDOW, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_SNAPTOGRID, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_SNAPTOGRID, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_TOOLPALETTE, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_TOOLPALETTE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_USEIDOMENUS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_EDITMODE, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_EDITMODE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_ENFORCERULES, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_ENFORCERULES, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_GRIDLINES, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_GRIDLINES, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_ADDE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_DELETEE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_ADDREL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_DELETERELATION, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            CheckMenuItem(GetMenu(hWnd), IDM_USEIDOMENUS, MF_BYCOMMAND | MF_UNCHECKED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETUSERMENUS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_RESETMENUS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETETEXT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_SETCURRENTENTITY, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
         }

         //Regen_WM_INITMENUPOPUP
         break;

      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         if(!CtlWnd)
         {         // Process Menu Commands
            //Regen_CustomMenuItems
            //Regen_CustomMenuItems
            switch(CtlId)  // Determine which Menu ID
            {
            case CM_FILENEW :
               //lRegen_Start_CM_FILENEW
               //lRegen_Start_CM_FILENEW
               fnidodialog(hWndClient, 0, NULL);
               //Regen_End_CM_FILENEW
               //Regen_End_CM_FILENEW
               break;
            case CM_FILEOPEN :
               //lRegen_Start_CM_FILEOPEN
               //lRegen_Start_CM_FILEOPEN
               szOFFilePath[0] = '\0';
               ofOF.lStructSize = sizeof(OPENFILENAME);
               ofOF.hwndOwner = hWnd;
               ofOF.lpstrFilter = szOFFilter;
               ofOF.lpstrCustomFilter = (LPSTR)NULL;
               ofOF.nMaxCustFilter = 0L;
               ofOF.nFilterIndex = 0;
               ofOF.lpstrFile= szOFFilePath;
               ofOF.nMaxFile = 256;
               ofOF.lpstrFileTitle = szOFFileTitle;
               ofOF.nMaxFileTitle = sizeof(szOFFileTitle);
               ofOF.lpstrInitialDir = NULL;
               ofOF.lpstrTitle = (LPSTR)"Open Diagram File";
               ofOF.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
               ofOF.nFileOffset = 0;
               ofOF.nFileExtension = 0;
               ofOF.lpstrDefExt = NULL;
               bOFRetCode = GetOpenFileName(&ofOF);
               //Regen_End_CM_FILEOPEN

               /*
                *   Read an IDO file.
                */
               if(bOFRetCode)
               {
                  fnidodialog(hWndClient, 0, NULL);
                  idoReadDiagram(GetActiveIDO(), szOFFilePath);
                  SetWindowText(GetParent(GetActiveIDO()), szOFFilePath);
                  idoSetFileName(GetActiveIDO(), szOFFilePath);
               }
               else
                  ;
//                  MessageBeep(0); // canceled file open

               //Regen_End_CM_FILEOPEN
               break;
            case IDM_CLOSE :
               //lRegen_Start_IDM_CLOSE
               {
                  HWND hIDO;
                  if(hIDO = GetActiveIDO())
                     SendMessage(GetParent(GetParent(hIDO)), WM_MDIDESTROY, (WPARAM)GetParent(hIDO), 0L);
               }
               //lRegen_Start_IDM_CLOSE
               //Regen_End_IDM_CLOSE
               //Regen_End_IDM_CLOSE
               break;
            case IDM_RESET :
               //lRegen_Start_IDM_RESET

               if(GetActiveIDO())
               {
                  if(IDYES == MessageBox(hWnd, "Would you like to save your diagram?", "Save Work", MB_ICONQUESTION | MB_YESNO))
                  {
                     SENDCOMMAND(hWnd, CM_FILESAVE, 0, 0);
                  }
                  idoResetDiagram(GetActiveIDO());
               }
               //lRegen_Start_IDM_RESET
               //Regen_End_IDM_RESET
               //Regen_End_IDM_RESET
               break;
            case CM_FILESAVE :
               //lRegen_Start_CM_FILESAVE

               if(!GetActiveIDO())
               {
                  MessageBeep(0);
                  return TRUE;
               }

               if(GetActiveIDO())
               {
                  lstrcpy(szSFFilePath, idoGetFileName(GetActiveIDO()));
                  if(lstrlen(szSFFilePath))
                  {
                     idoSaveDiagram(GetActiveIDO(), szSFFilePath);
                     return TRUE;
                  }
               }
               //lRegen_Start_CM_FILESAVE
               szSFFilePath[0] = '\0';
               ofSF.lStructSize = sizeof(OPENFILENAME);
               ofSF.hwndOwner = hWnd;
               ofSF.lpstrFilter = szSFFilter;
               ofSF.lpstrCustomFilter = (LPSTR)NULL;
               ofSF.nMaxCustFilter = 0L;
               ofSF.nFilterIndex = 0;
               ofSF.lpstrFile = szSFFilePath;
               ofSF.nMaxFile = 256;
               ofSF.lpstrFileTitle = szSFFileTitle;
               ofSF.nMaxFileTitle = sizeof(szSFFileTitle);
               ofSF.lpstrInitialDir = NULL;
               ofSF.lpstrTitle = (LPSTR)"Save Diagram File";
               ofSF.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
               ofSF.nFileOffset = 0;
               ofSF.nFileExtension = 0;
               ofSF.lpstrDefExt = (LPSTR)"IDO";
               bSFRetCode = GetSaveFileName(&ofSF);
               //Regen_End_CM_FILESAVE
               /*
                *   Save an IDO file.
                */
               if(bSFRetCode)
               {
                  idoSaveDiagram(GetActiveIDO(), szSFFilePath);
                  SetWindowText(GetParent(GetActiveIDO()), szSFFilePath);
                  idoSetFileName(GetActiveIDO(), szSFFilePath);
               }
               //Regen_End_CM_FILESAVE
               break;
            case IDM_SAVEAS :
               //lRegen_Start_IDM_SAVEAS

               if(!GetActiveIDO())
               {
                  MessageBeep(0);
                  return TRUE;
               }

               szSFFilePath[0] = '\0';
               ofSF.lStructSize = sizeof(OPENFILENAME);
               ofSF.hwndOwner = hWnd;
               ofSF.lpstrFilter = szSFFilter;
               ofSF.lpstrCustomFilter = (LPSTR)NULL;
               ofSF.nMaxCustFilter = 0L;
               ofSF.nFilterIndex = 0;
               ofSF.lpstrFile = szSFFilePath;
               ofSF.nMaxFile = 256;
               ofSF.lpstrFileTitle = szSFFileTitle;
               ofSF.nMaxFileTitle = sizeof(szSFFileTitle);
               ofSF.lpstrInitialDir = NULL;
               ofSF.lpstrTitle = (LPSTR)"Save Diagram File";
               ofSF.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_SHOWHELP;
               ofSF.nFileOffset = 0;
               ofSF.nFileExtension = 0;
               ofSF.lpstrDefExt = (LPSTR)"IDO";
               bSFRetCode = GetSaveFileName(&ofSF);
               /*
                *   Save an IDO file.
                */
               if(bSFRetCode)
               {
                  idoSaveDiagram(GetActiveIDO(), szSFFilePath);
                  SetWindowText(GetParent(GetActiveIDO()), szSFFilePath);
                  idoSetFileName(GetActiveIDO(), szSFFilePath);
               }

               //lRegen_Start_IDM_SAVEAS
               //Regen_End_IDM_SAVEAS
               //Regen_End_IDM_SAVEAS
               break;
            case IDM_RESETPALETTE :
               //lRegen_Start_IDM_RESETPALETTE
               idoResetPalette(GetActiveIDO());
               //lRegen_Start_IDM_RESETPALETTE
               //Regen_End_IDM_RESETPALETTE
               //Regen_End_IDM_RESETPALETTE
               break;
            case IDM_LOADPALETTE :
               //lRegen_Start_IDM_LOADPALETTE
               //lRegen_Start_IDM_LOADPALETTE
               szPALETTEFilePath[0] = '\0';
               ofPALETTE.lStructSize = sizeof(OPENFILENAME);
               ofPALETTE.hwndOwner = hWnd;
               ofPALETTE.lpstrFilter = szPALETTEFilter;
               ofPALETTE.lpstrCustomFilter = (LPSTR)NULL;
               ofPALETTE.nMaxCustFilter = 0L;
               ofPALETTE.nFilterIndex = 0;
               ofPALETTE.lpstrFile= szPALETTEFilePath;
               ofPALETTE.nMaxFile = 256;
               ofPALETTE.lpstrFileTitle = szPALETTEFileTitle;
               ofPALETTE.nMaxFileTitle = sizeof(szPALETTEFileTitle);
               ofPALETTE.lpstrInitialDir = NULL;
               ofPALETTE.lpstrTitle = (LPSTR)"Open Palette File";
               ofPALETTE.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
               ofPALETTE.nFileOffset = 0;
               ofPALETTE.nFileExtension = 0;
               ofPALETTE.lpstrDefExt = NULL;
               bPALETTERetCode = GetOpenFileName(&ofPALETTE);
               //Regen_End_IDM_LOADPALETTE
               if(bPALETTERetCode)
                  idoReadPalette(GetActiveIDO(), szPALETTEFilePath);
               //Regen_End_IDM_LOADPALETTE
               break;
            case IDM_SAVEPALETTE :
               //lRegen_Start_IDM_SAVEPALETTE
               //lRegen_Start_IDM_SAVEPALETTE
               szPLT2FilePath[0] = '\0';
               ofPLT2.lStructSize = sizeof(OPENFILENAME);
               ofPLT2.hwndOwner = hWnd;
               ofPLT2.lpstrFilter = szPLT2Filter;
               ofPLT2.lpstrCustomFilter = (LPSTR)NULL;
               ofPLT2.nMaxCustFilter = 0L;
               ofPLT2.nFilterIndex = 0;
               ofPLT2.lpstrFile = szPLT2FilePath;
               ofPLT2.nMaxFile = 256;
               ofPLT2.lpstrFileTitle = szPLT2FileTitle;
               ofPLT2.nMaxFileTitle = sizeof(szPLT2FileTitle);
               ofPLT2.lpstrInitialDir = NULL;
               ofPLT2.lpstrTitle = (LPSTR)"Save Palette File";
               ofPLT2.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
               ofPLT2.nFileOffset = 0;
               ofPLT2.nFileExtension = 0;
               ofPLT2.lpstrDefExt = (LPSTR)"PLT";
               bPLT2RetCode = GetSaveFileName(&ofPLT2);
               //Regen_End_IDM_SAVEPALETTE
               if(bPLT2RetCode)
                  idoSavePalette(GetActiveIDO(), szPLT2FilePath);
               //Regen_End_IDM_SAVEPALETTE
               break;
            case CM_FILEPRINT :
               //lRegen_Start_CM_FILEPRINT

               /*
                *   Print the IDO.
                */
                idoPrintDiagram(GetActiveIDO());

               //lRegen_Start_CM_FILEPRINT
               //Regen_End_CM_FILEPRINT
               //Regen_End_CM_FILEPRINT
               break;
            case CM_EXIT :
               //lRegen_Start_CM_EXIT
               //lRegen_Start_CM_EXIT
               //Regen_End_CM_EXIT
               //Regen_End_CM_EXIT
               SendMessage (hWnd, WM_CLOSE, 0, 0L);
               return 0;

            case IDM_CUT :
               //lRegen_Start_IDM_CUT

               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_CUT, 0, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_CUT
               //Regen_End_IDM_CUT
               //Regen_End_IDM_CUT
               break;
            case IDM_COPY :
               //lRegen_Start_IDM_COPY

               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_COPY, 0, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_COPY
               //Regen_End_IDM_COPY
               //Regen_End_IDM_COPY
               break;
            case IDM_PASTE :
               //lRegen_Start_IDM_PASTE

               if(GetActiveIDO())
                  SendMessage(GetActiveIDO(), WM_PASTE, 0, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_PASTE
               //Regen_End_IDM_PASTE
               //Regen_End_IDM_PASTE
               break;
            case IDM_ZOOMIN :
               //lRegen_Start_IDM_ZOOMIN

               if(GetActiveIDO())
                  idoZoom(GetActiveIDO(), IDO_ZOOM_IN, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_ZOOMIN
               //Regen_End_IDM_ZOOMIN
               //Regen_End_IDM_ZOOMIN
               break;
            case IDM_ZOOMOUT :
               //lRegen_Start_IDM_ZOOMOUT

               if(GetActiveIDO())
                  idoZoom(GetActiveIDO(), IDO_ZOOM_OUT, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_ZOOMOUT
               //Regen_End_IDM_ZOOMOUT
               //Regen_End_IDM_ZOOMOUT
               break;
            case IDM_ZOOMTOFITWINDOW :
               //lRegen_Start_IDM_ZOOMTOFITWINDOW

               if(GetActiveIDO())
                  idoZoom(GetActiveIDO(), IDO_ZOOM_TO_FIT, 0L);
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_ZOOMTOFITWINDOW
               //Regen_End_IDM_ZOOMTOFITWINDOW
               //Regen_End_IDM_ZOOMTOFITWINDOW
               break;
            case IDM_USEIDOMENUS :
               //lRegen_Start_IDM_USEIDOMENUS

               /*
                *   Toggle displaying IDO menus.
                */
               IDO_ToggleUserIdoMenus(GetActiveIDO());

               //lRegen_Start_IDM_USEIDOMENUS
               //Regen_End_IDM_USEIDOMENUS
               //Regen_End_IDM_USEIDOMENUS
               break;
            case IDM_GRIDLINES :
               //lRegen_Start_IDM_GRIDLINES

               if(GetActiveIDO())
                  IDO_ToggleGrid(GetActiveIDO());
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_GRIDLINES
               //Regen_End_IDM_GRIDLINES
               //Regen_End_IDM_GRIDLINES
               break;
            case IDM_SNAPTOGRID :
               //lRegen_Start_IDM_SNAPTOGRID

               if(GetActiveIDO())
                  IDO_ToggleSnap(GetActiveIDO());
               else
                  MessageBeep(0);

               //lRegen_Start_IDM_SNAPTOGRID
               //Regen_End_IDM_SNAPTOGRID
               //Regen_End_IDM_SNAPTOGRID
               break;
            case IDM_EDITMODE :
               //lRegen_Start_IDM_EDITMODE

               /*
                *   Toggle edit mode.
                */
               IDO_ToggleEditMode(GetActiveIDO());

               //lRegen_Start_IDM_EDITMODE
               //Regen_End_IDM_EDITMODE
               //Regen_End_IDM_EDITMODE
               break;
            case IDM_ENFORCERULES :
               //lRegen_Start_IDM_ENFORCERULES

               /*
                *   Toggle rules.
                */
               if(idoGetRulesEnforced(GetActiveIDO()))
                  idoSetRulesEnforced(GetActiveIDO(), FALSE);
               else
                  idoSetRulesEnforced(GetActiveIDO(), TRUE);

               //lRegen_Start_IDM_ENFORCERULES
               //Regen_End_IDM_ENFORCERULES
               //Regen_End_IDM_ENFORCERULES
               break;
            case IDM_DISPLAYMESSAGES :
               //lRegen_Start_IDM_DISPLAYMESSAGES

               bMsg = !bMsg;

               //lRegen_Start_IDM_DISPLAYMESSAGES
               //Regen_End_IDM_DISPLAYMESSAGES
               //Regen_End_IDM_DISPLAYMESSAGES
               break;
            case IDM_ADDENTITY :
               //lRegen_Start_IDM_ADDENTITY
               //lRegen_Start_IDM_ADDENTITY
               if(fnaddentity(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_ADDENTITY
               //Regen_End_IDM_ADDENTITY
               break;
            case IDM_ADDRELATION :
               //lRegen_Start_IDM_ADDRELATION
               //lRegen_Start_IDM_ADDRELATION
               if(fnaddrelation(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_ADDRELATION
               //Regen_End_IDM_ADDRELATION
               break;
            case IDM_DELETEENTITY :
               //lRegen_Start_IDM_DELETEENTITY
               //lRegen_Start_IDM_DELETEENTITY
               if(fndeleteentity(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_DELETEENTITY
               //Regen_End_IDM_DELETEENTITY
               break;
            case IDM_DELETERELATION :
               //lRegen_Start_IDM_DELETERELATION
               //lRegen_Start_IDM_DELETERELATION
               if(fndelrel(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_DELETERELATION
               //Regen_End_IDM_DELETERELATION
               break;
            case IDM_SETCURRENTENTITYTEXT :
               //lRegen_Start_IDM_SETCURRENTENTITYTEXT
               //lRegen_Start_IDM_SETCURRENTENTITYTEXT
               if(fnsettext(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_SETCURRENTENTITYTEXT
               //Regen_End_IDM_SETCURRENTENTITYTEXT
               break;
            case IDM_SETITEMFONT :
               //lRegen_Start_IDM_SETITEMFONT
               //lRegen_Start_IDM_SETITEMFONT
               cfCF.lStructSize = sizeof(CHOOSEFONT);
               cfCF.hwndOwner = hWnd;
               cfCF.lpLogFont = &lfCF;
               cfCF.nFontType = SCREEN_FONTTYPE;
               cfCF.nSizeMin  = 0;
               cfCF.nSizeMax  = 32;
               cfCF.Flags = CF_ANSIONLY | CF_SCREENFONTS;
               bCFRetCode = ChooseFont(&cfCF);
               //Regen_End_IDM_SETITEMFONT
               SetItemFont(&lfCF);
               //Regen_End_IDM_SETITEMFONT
               break;
            case IDM_COLOR :
               //lRegen_Start_IDM_COLOR
               idoPropertyPage(GetActiveIDO(), PP_IDO_COLORS);

               //lRegen_Start_IDM_COLOR
               //Regen_End_IDM_COLOR
               //Regen_End_IDM_COLOR
               break;
            case IDM_GRID :
               //lRegen_Start_IDM_GRID
               idoPropertyPage(GetActiveIDO(), PP_IDO_GRID);

               //lRegen_Start_IDM_GRID
               //Regen_End_IDM_GRID
               //Regen_End_IDM_GRID
               break;
            case IDM_TEXT :
               //lRegen_Start_IDM_TEXT
               {
                  ENTITY entity;
                  if(idoGetCurrentEntity(GetActiveIDO(), &entity))
                     idoEntityPropertyPage(&entity, IDO_PPE_TEXT);
               }
               //lRegen_Start_IDM_TEXT
               //Regen_End_IDM_TEXT
               //Regen_End_IDM_TEXT
               break;
            case IDM1_COLOR :
               //lRegen_Start_IDM1_COLOR
               {
                  ENTITY entity;
                  if(idoGetCurrentEntity(GetActiveIDO(), &entity))
                     idoEntityPropertyPage(&entity, IDO_PPE_COLORS);
               }
               //lRegen_Start_IDM1_COLOR
               //Regen_End_IDM1_COLOR
               //Regen_End_IDM1_COLOR
               break;
            case IDM_SHAPE :
               //lRegen_Start_IDM_SHAPE
               {
                  ENTITY entity;
                  if(idoGetCurrentEntity(GetActiveIDO(), &entity))
                     idoEntityPropertyPage(&entity, IDO_PPE_STYLES);
               }
               //lRegen_Start_IDM_SHAPE
               //Regen_End_IDM_SHAPE
               //Regen_End_IDM_SHAPE
               break;
            case IDM_GRAPHIC :
               //lRegen_Start_IDM_GRAPHIC
               {
                  ENTITY entity;
                  if(idoGetCurrentEntity(GetActiveIDO(), &entity))
                     idoEntityPropertyPage(&entity, IDO_PPE_GRAPHICS);
               }
               //lRegen_Start_IDM_GRAPHIC
               //Regen_End_IDM_GRAPHIC
               //Regen_End_IDM_GRAPHIC
               break;
            case IDM1_TEXT :
               //lRegen_Start_IDM1_TEXT
               {
                  RELATION relation;
                  if(idoGetCurrentRelation(GetActiveIDO(), &relation))
                     idoRelationPropertyPage(&relation, IDO_PPR_TEXT);
               }
               //lRegen_Start_IDM1_TEXT
               //Regen_End_IDM1_TEXT
               //Regen_End_IDM1_TEXT
               break;
            case IDM1_SHAPE :
               //lRegen_Start_IDM1_SHAPE
               {
                  RELATION relation;
                  if(idoGetCurrentRelation(GetActiveIDO(), &relation))
                     idoRelationPropertyPage(&relation, IDO_PPR_STYLES);
               }
               //lRegen_Start_IDM1_SHAPE
               //Regen_End_IDM1_SHAPE
               //Regen_End_IDM1_SHAPE
               break;
            case IDM2_COLOR :
               //lRegen_Start_IDM2_COLOR
               {
                  RELATION relation;
                  if(idoGetCurrentRelation(GetActiveIDO(), &relation))
                     idoRelationPropertyPage(&relation, IDO_PPR_COLORS);
               }
               //lRegen_Start_IDM2_COLOR
               //Regen_End_IDM2_COLOR
               //Regen_End_IDM2_COLOR
               break;
            case IDM_TOOLPALETTE :
               //lRegen_Start_IDM_TOOLPALETTE

               /*
                *   Toggle tool palette.
                */
               IDO_TogglePalette(GetActiveIDO());

               //lRegen_Start_IDM_TOOLPALETTE
               //Regen_End_IDM_TOOLPALETTE
               //Regen_End_IDM_TOOLPALETTE
               break;
            case IDM_COLORPALETTE :
               //lRegen_Start_IDM_COLORPALETTE
               //lRegen_Start_IDM_COLORPALETTE
//Lock
               if(fncolorset(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_COLORPALETTE
               //Regen_End_IDM_COLORPALETTE
               break;
            case IDM_ALIGNMENTPALETTE :
               //lRegen_Start_IDM_ALIGNMENTPALETTE
               //lRegen_Start_IDM_ALIGNMENTPALETTE
//Lock
               if(fnaligner(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_ALIGNMENTPALETTE
               //Regen_End_IDM_ALIGNMENTPALETTE
               break;
            case IDM_REFRESHIDO :
               //lRegen_Start_IDM_REFRESHIDO

               /*
                *   Redraw the IDO.
                */
               InvalidateRect(GetActiveIDO(), NULL, TRUE);
               UpdateWindow(GetActiveIDO());

               //lRegen_Start_IDM_REFRESHIDO
               //Regen_End_IDM_REFRESHIDO
               //Regen_End_IDM_REFRESHIDO
               break;
            case CM_CASCADECHILDREN :
               //lRegen_Start_CM_CASCADECHILDREN
               //lRegen_Start_CM_CASCADECHILDREN
               //Regen_End_CM_CASCADECHILDREN
               //Regen_End_CM_CASCADECHILDREN
               SendMessage (hWndClient, WM_MDICASCADE, 0, 0L);
               return 0;

            case CM_TILECHILDREN :
               //lRegen_Start_CM_TILECHILDREN
               //lRegen_Start_CM_TILECHILDREN
               //Regen_End_CM_TILECHILDREN
               //Regen_End_CM_TILECHILDREN
               SendMessage (hWndClient, WM_MDITILE, 0, 0L);
               return 0;

            case CM_ARRANGEICONS :
               //lRegen_Start_CM_ARRANGEICONS
               //lRegen_Start_CM_ARRANGEICONS
               //Regen_End_CM_ARRANGEICONS
               SendMessage (hWndClient, WM_MDIICONARRANGE, 0, 0L);
               //Regen_End_CM_ARRANGEICONS
               break;
            case CM_CLOSECHILDREN :
               //lRegen_Start_CM_CLOSECHILDREN
               //lRegen_Start_CM_CLOSECHILDREN
               //Regen_End_CM_CLOSECHILDREN
               EnumChildWindows (hWndClient, CloseEnumProc, 0L);
               //Regen_End_CM_CLOSECHILDREN
               break;
            case IDM_HELP :
               //lRegen_Start_IDM_HELP
               WinHelp(hWnd, (LPSTR)"pvido.hlp", HELP_CONTENTS, 0);
               //lRegen_Start_IDM_HELP
               //Regen_End_IDM_HELP
               //Regen_End_IDM_HELP
               break;
            case IDM_ABOUT :
               //lRegen_Start_IDM_ABOUT
               //lRegen_Start_IDM_ABOUT
               if(fnAboutidoiface(hWnd, 0, NULL))
               {
               }
               //Regen_End_IDM_ABOUT
               //Regen_End_IDM_ABOUT
               break;
            default :
               if(hWndChild = (HWND)SendMessage(hWndClient, WM_MDIGETACTIVE, 0, 0))
                  SendMessage(hWndChild, WM_COMMAND, wParam, lParam);
            }
         }
         else
         {
            //Regen_CustomCommand
            //Regen_CustomCommand

            switch(CtlId)
            {
            }
         }
         break;

      case WM_MENUSELECT :

         //Regen_WM_MENUSELECT
         //Regen_WM_MENUSELECT

         vwProcessDSL(hWnd, uMessage, wParam, lParam);
         break;

      case WM_QUERYENDSESSION:
      case WM_CLOSE:       // Attempt to close all children

         EnumChildWindows (hWndClient, CloseEnumProc, 0L);

         if (NULL != GetWindow (hWndClient, GW_CHILD))
              return 0;

         //Regen_WM_Close
         //Regen_WM_Close

         PostQuitMessage(0);
         break;   // ie, call DefFrameProc;
      case WM_SIZE :
         //lRegen_WM_Size
         //lRegen_WM_Size
         vwSizeToolBars(hWnd);
         vwSizeMDIClient(hWnd, hWndClient, TRUE);
         return 0;


      default :
          return DefFrameProc(hWnd, hWndClient, uMessage, wParam, lParam);
   }
   return DefFrameProc(hWnd, hWndClient, uMessage, wParam, lParam);
}

BOOL CALLBACK EXPORT CloseEnumProc(HWND hWnd, LONG lParam)
{
   if(!IsWindow(hWnd))
      return 1;

   //Regen_CloseChildren
   //Regen_CloseChildren
   SendMessage(GetParent(hWnd), WM_MDIDESTROY, (WPARAM)hWnd, 0L);
      return 1;
}
//Regen_CustomCode


HWND GetActiveIDO()
{
   HWND hWndMDIClient = hWndClient;
   HWND hIDOdialog;
   HWND hIDO = 0;


   hIDOdialog = (HWND)SendMessage(hWndMDIClient, WM_MDIGETACTIVE, 0, 0L);
   if(IsWindow(hIDOdialog))
      hIDO = GetDlgItem(hIDOdialog, IDC_IDO);


   return hIDO;
}



LRESULT CALLBACK EXPORT fnMDIWndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam)
{
GETVIEW;
   WORD CtlId;
   WORD Notify;
   HWND CtlWnd;

   switch(uMessage)
   {
      case WM_COMMAND :
      #ifdef WIN32
         CtlId  = LOWORD(wParam);
         Notify = HIWORD(wParam);
         CtlWnd = (HWND)lParam;
      #else
         CtlId  = wParam;
         Notify = HIWORD(lParam);
         CtlWnd = (HWND)LOWORD(lParam);
      #endif
         switch(CtlId)
         {
         }
         break;

      case WM_DESTROY :
         break;
   }
   return DefViewProc(hWnd, uMessage, wParam, lParam);
}


void SetItemFont(LOGFONT * lfCF)
{
   HWND hIDO;
   ENTITY entity;
   RELATION relation;
   IDO_FONT idoFont;


   lstrcpy(idoFont.szFontName, (LPSTR)lfCF->lfFaceName);
   idoFont.cSize = lfCF->lfHeight;
   idoFont.bBold = FALSE;
   if(lfCF->lfCharSet >= 500)
      idoFont.bBold = TRUE;
   idoFont.bItalic = (BOOL)lfCF->lfItalic;
   idoFont.bUnderline = (BOOL)lfCF->lfUnderline;
   idoFont.bStrikeout = (BOOL)lfCF->lfStrikeOut;

   if(hIDO = GetActiveIDO())
   {
      // try to get the current entity
      if(idoGetCurrentEntity(hIDO, &entity))
      {
         idoIterateSelectedEntityFirst(hIDO);
         while(idoIterateSelectedEntityNext(hIDO, &entity))
            idoEntitySetFont(&entity, &idoFont);
      }
      else
         // try to get the current line
         if(idoGetCurrentRelation(hIDO, &relation))
            idoRelationSetFont(&relation, &idoFont);

      InvalidateRect(hIDO, NULL, TRUE);
      UpdateWindow(hIDO);
   }

}
//Regen_CustomCode
