# 
#  Makefile for ANSI C application : idoiface
# 
SRCDIR = ./
INCDIR = ./
OBJDIR = ./
RESDIR = ./
LIBDIR = ./
EXEDIR = ./
LNKRSP = @.\idoiface.lnk

# Error listing file
ERROUT    = >> Errors

CC        = cl.exe
LINK      = link.exe
RC        = rc.exe
IMPLIB    = implib.exe
CFLAGS    = -D_DEBUG -DWIN31 -nologo -c -Gs -W3 -AL -Zi -Od -GA
CDEFINES  = 
LINKFLAGS = /nod /B /CO
COMPILE   = $(CC) $(CFLAGS) $(CDEFINES)

ALL : $(EXEDIR)interact.exe

.Silent:

$(OBJDIR)idoiface.obj : $(SRCDIR)idoiface.c
   echo compiling idoiface.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)idoiface.c $(ERROUT)

$(OBJDIR)TopToolb.obj : $(SRCDIR)TopToolb.c
   echo compiling TopToolb.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)TopToolb.c $(ERROUT)

$(OBJDIR)StatusLi.obj : $(SRCDIR)StatusLi.c
   echo compiling StatusLi.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)StatusLi.c $(ERROUT)

$(OBJDIR)Aboutido.obj : $(SRCDIR)Aboutido.c
   echo compiling Aboutido.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)Aboutido.c $(ERROUT)

$(OBJDIR)idodialo.obj : $(SRCDIR)idodialo.c
   echo compiling idodialo.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)idodialo.c $(ERROUT)

$(OBJDIR)addentit.obj : $(SRCDIR)addentit.c
   echo compiling addentit.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)addentit.c $(ERROUT)

$(OBJDIR)deleteen.obj : $(SRCDIR)deleteen.c
   echo compiling deleteen.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)deleteen.c $(ERROUT)

$(OBJDIR)addrelat.obj : $(SRCDIR)addrelat.c
   echo compiling addrelat.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)addrelat.c $(ERROUT)

$(OBJDIR)settext.obj : $(SRCDIR)settext.c
   echo compiling settext.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)settext.c $(ERROUT)

$(OBJDIR)currente.obj : $(SRCDIR)currente.c
   echo compiling currente.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)currente.c $(ERROUT)

$(OBJDIR)Banner.obj : $(SRCDIR)Banner.c
   echo compiling Banner.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)Banner.c $(ERROUT)

$(OBJDIR)aligner.obj : $(SRCDIR)aligner.c
   echo compiling aligner.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)aligner.c $(ERROUT)

$(OBJDIR)colorset.obj : $(SRCDIR)colorset.c
   echo compiling colorset.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)colorset.c $(ERROUT)

$(OBJDIR)delrel.obj : $(SRCDIR)delrel.c
   echo compiling delrel.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)delrel.c $(ERROUT)

$(OBJDIR)iface.obj : $(SRCDIR)iface.c
   echo compiling iface.c
   $(COMPILE) -Fo$(OBJDIR)  $(SRCDIR)iface.c $(ERROUT)

$(RESDIR)idoiface.res : $(RESDIR)idoiface.rc $(INCDIR)Resource.h  $(RESDIR)*.dlg 
   echo compiling Resources...
   $(RC) -r $(RESDIR)idoiface.rc $(ERROUT)

$(EXEDIR)interact.exe : $(OBJDIR)idoiface.obj \
   $(RESDIR)idoiface.res \
   $(LIBDIR)idoiface.def \
   $(OBJDIR)TopToolb.obj \
   $(OBJDIR)StatusLi.obj \
   $(OBJDIR)Aboutido.obj \
   $(OBJDIR)idodialo.obj \
   $(OBJDIR)addentit.obj \
   $(OBJDIR)deleteen.obj \
   $(OBJDIR)addrelat.obj \
   $(OBJDIR)settext.obj \
   $(OBJDIR)currente.obj \
   $(OBJDIR)Banner.obj \
   $(OBJDIR)aligner.obj \
   $(OBJDIR)colorset.obj \
   $(OBJDIR)delrel.obj \
   $(OBJDIR)iface.obj \
   
    echo linking...
    $(LINK) $(LINKFLAGS) $(LNKRSP) $(ERROUT)
    echo Combining resources...
    $(RC) -K $(RESDIR)idoiface.res $(EXEDIR)interact.exe $(ERROUT)
   echo Finished
#*******************************************************************#
